local SEND_IN_PROGRESS = "%d mails to send, please wait %s ..."
local SEND_DONE = "Done sending mails."
local SEND_ERROR = "Not sending your mails for some reason."
local INVALID_RANK = "Rank %q is not a valid guild rank."

local addon = CreateFrame("Frame")
local guildRanks = {}
local guildMembers = {}
local queue = {}
local mailAvailable = nil
local pName = UnitName("player")

local subject = nil
local body = nil

local total = 0
local function processQueue(self, elapsed)
	total = total + elapsed
	if total > 2 then
		if #queue > 0 then
			local recipient = table.remove(queue)
			SendMail(recipient, subject, body)
			if #queue == 0 then
				print(SEND_DONE)
			end
		end
		total = 0
	end
end

addon:SetScript("OnEvent", function(self, event, ...) self[event](self, ...) end)
function addon:GUILD_ROSTER_UPDATE()
	wipe(guildRanks)
	wipe(guildMembers)
	for i = 1, GuildControlGetNumRanks() do
		guildRanks[(GuildControlGetRankName(i))] = i
	end
	for i = 1, GetNumGuildMembers(true) do
		local n, _, r = GetGuildRosterInfo(i)
		if n and n ~= pName then guildMembers[n] = r + 1 end
	end
end
function addon:MAIL_CLOSED()
	wipe(queue)
	mailAvailable = nil
end
function addon:MAIL_SHOW()
	if IsInGuild() then GuildRoster() end
	mailAvailable = true
end
addon:RegisterEvent("GUILD_ROSTER_UPDATE")
addon:RegisterEvent("MAIL_CLOSED")
addon:RegisterEvent("MAIL_SHOW")
addon:Hide()
addon:SetScript("OnUpdate", processQueue)

_G.SlashCmdList["POSTMASTER_SHORTHAND"] = function(input)
	if not mailAvailable or #queue > 1 then return end
	local andUp = nil
	if input:find("+$") then
		andUp = true
		input = input:sub(1, #input - 1)
	end
	if not guildRanks[input] then
		print(INVALID_RANK:format(input))
		return
	end
	wipe(queue)
	local rankIndex = guildRanks[input]
	if not rankIndex then return end
	for name, rank in pairs(guildMembers) do
		if andUp and rank <= rankIndex then
			queue[#queue + 1] = name
		elseif not andUp and rank == rankIndex then
			queue[#queue + 1] = name
		end
	end
	subject = SendMailSubjectEditBox:GetText():trim()
	body = SendMailBodyEditBox:GetText():trim()
	if subject and subject:len() > 3 and body and body:len() > 3 then
		print(SEND_IN_PROGRESS:format(#queue, SecondsToTime(#queue * 2)))
		addon:Show()
	else
		subject = nil
		body = nil
		wipe(queue)
		print(SEND_ERROR)
	end
end
_G.SLASH_POSTMASTER_SHORTHAND1 = "/postmaster"

